// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) DIGITEO - 2009 - Allan CORNET
// 
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

SCILAB_VERSION = getversion();

[SCILAB_PRIMITIVES , SCILAB_COMMANDS] = what();

SCILAB_PRIMITIVES = strcat(SCILAB_PRIMITIVES, ascii(13));
SCILAB_COMMANDS = strcat(SCILAB_COMMANDS, ascii(13))


libs = librarieslist();
SCILAB_LIBRARIES = strcat(libs, ascii(13))

libs = librarieslist();

SCILAB_MACROS = '';
for i=1:size(libs,'*')
	macros = libraryinfo(libs(i));
  SCILAB_MACROS = [SCILAB_MACROS ; macros];
end

SCILAB_MACROS = strcat(SCILAB_MACROS, ascii(13))

clear i
clear macros
clear libs

SCILAB_GLOBAL_VARIABLES = who('global');
SCILAB_GLOBAL_VARIABLES = strcat(SCILAB_GLOBAL_VARIABLES, ' ');

SCILAB_LOCAL_VARIABLES = who('local');
// remove librairies
libs = librarieslist();
for i=1:size(libs,'*')
  SCILAB_LOCAL_VARIABLES = strsubst(SCILAB_LOCAL_VARIABLES,libs(i),'');
end

SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == '') = [];
SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == 'SCILAB_LOCAL_VARIABLES') = [];
SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == 'SCILAB_GLOBAL_VARIABLES') = [];
SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == 'SCILAB_MACROS') = [];
SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == 'SCILAB_LIBRARIES') = [];
SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == 'SCILAB_PRIMITIVES') = [];
SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == 'SCILAB_COMMANDS') = [];
SCILAB_LOCAL_VARIABLES(SCILAB_LOCAL_VARIABLES == 'SCILAB_VERSION') = [];

SCILAB_LOCAL_VARIABLES = strcat(SCILAB_LOCAL_VARIABLES, ascii(13))

clear i
clear libs

PATH_TEMPLATE = get_absolute_file_path('generate_scilab_uew.sce');
if fileinfo(PATH_TEMPLATE + filesep() + 'scilab_template.uew') <> [] then
  TEMPLATE_UEW = mgetl(PATH_TEMPLATE + 'scilab_template.uew');
  MODIFIED_UEW = strsubst(TEMPLATE_UEW, "__SCILAB_VERSION__", SCILAB_VERSION);
  MODIFIED_UEW = strsubst(MODIFIED_UEW, "__SCILAB_COMMANDS__", SCILAB_COMMANDS);
  MODIFIED_UEW = strsubst(MODIFIED_UEW, "__SCILAB_PRIMITIVES__", SCILAB_PRIMITIVES);
  MODIFIED_UEW = strsubst(MODIFIED_UEW, "__SCILAB_MACROS__", SCILAB_MACROS);
  MODIFIED_UEW = strsubst(MODIFIED_UEW, "__SCILAB_LIBRARIES__", SCILAB_LIBRARIES);
  MODIFIED_UEW = strsubst(MODIFIED_UEW, "__SCILAB_LOCAL_VARIABLES__", SCILAB_LOCAL_VARIABLES);
  MODIFIED_UEW = strsubst(MODIFIED_UEW, "__SCILAB_GLOBAL_VARIABLES__", SCILAB_GLOBAL_VARIABLES);
  
  MODIFIED_UEW = stripblanks(MODIFIED_UEW);

  TEMPLATE_UEW = mputl(MODIFIED_UEW, PATH_TEMPLATE + SCILAB_VERSION + '.uew');
  
else
	error(999, PATH_TEMPLATE + filesep() + 'scilab_template.uew not found.');
end

clear TEMPLATE_UEW
clear MODIFIED_UEW
clear PATH_TEMPLATE
clear SCILAB_LOCAL_VARIABLES
clear SCILAB_GLOBAL_VARIABLES
clear SCILAB_MACROS
clear SCILAB_LIBRARIES 
clear SCILAB_PRIMITIVES
clear SCILAB_COMMANDS 
clear SCILAB_VERSION
clear mputl

